#!/usr/bin/perl

# $Id: unpack_prime.pl,v 1.5 2012/06/12 14:19:06 fclement Exp $

# unpacking primes enclosed in the files of the pool
# use this to do tests. It's written in perl with, in
# sight, a simple C implementation.

use warnings;
use strict;

my $datadir = "work";

for (@ARGV) {
    open my $f, '<', "$datadir/$_" or die "cannot open pool file";
    local $/;
    my $data = substr <$f>, 20;
    my ($block_tag, $string_tag) =
      unpack "C2", $data;
    die "invalid string tag"
      if ($string_tag != 0x09 && $string_tag != 0x0a);
    my $string_len;
    $data = substr $data, 2;
    if ($string_tag == 0x09)
      {$string_len = unpack "C", $data; $data = substr $data, 1}
    else
      {$string_len = unpack "N", $data; $data = substr $data, 4}
    print unpack "A$string_len", $data;
    print "\n";
}
